//+------------------------------------------------------------------+
//|                                                          rmo.mq4 |
//|                                                           mladen |
//| Rahul Mohindar Oscillator                                        |
//| originaly developed by : ????????                                |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers    2
#property indicator_color1     Red
#property indicator_color2     DimGray
#property indicator_width2     2
#property indicator_levelcolor MediumOrchid

//
//
//
//
//

extern int    Depth           = 10;
extern int    Smooth          = 81;
extern int    Price           = PRICE_CLOSE;

extern string note            = "turn on Alert = true";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern string soundfile       = "alert2.wav";

//
//
//
//
//

#define MAX_depth 20
double  buffer1[];
double  buffer2[];
double  buffer3[];
double  buffer4[];
double  trend[];
double  pBuffer[][MAX_depth];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
      SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,buffer2);
      SetIndexBuffer(2,buffer3);
      SetIndexBuffer(3,buffer4);
      SetIndexBuffer(4,trend);
      SetLevelValue(0,0);
      Depth = MathMax(MathMin(Depth,MAX_depth),2);
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double alpha = 2.0/(Smooth+1.0);
   int    counted_bars=IndicatorCounted();
   int    i,r,limit;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (ArrayRange(pBuffer,0) != Bars) ArrayResize(pBuffer,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      buffer4[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double high   = buffer4[ArrayMaximum(buffer4,Depth,i)];
      double low    = buffer4[ArrayMinimum(buffer4,Depth,i)];
      double iprice = buffer4[i];
      double price  = iprice;
      double sum    = 0;
      
      //
      //
      //
      //
      //
      
      for (int k=1; k<=Depth; k++)
      {
         pBuffer[r][k-1] = price;
         price           = (pBuffer[r][k-1]+pBuffer[r-1][k-1])/2.0;
         sum            += price;
      }
      
      //
      //
      //
      //
      //
      
      if ((high-low) != 0)
            buffer3[i] = 100*(iprice-sum/(Depth*1.0))/(high-low);
      else  buffer3[i] = 0;
      buffer2[i] = buffer2[i+1]+alpha*(buffer3[i]-buffer2[i+1]);
      buffer1[i] = buffer2[i];
      trend[i]   = trend[i+1];
      if (buffer2[i] > 0) trend[i] = 1;
      if (buffer2[i] < 0) trend[i] =-1;
      }
      
      if (alertsOn)
         {
         if (alertsOnCurrent)
              int whichBar = 0;
         else     whichBar = 1;

         //
         //
         //
         //
         //
         
         if (trend[whichBar] != trend[whichBar+1])
         if (trend[whichBar] == 1)
               doAlert("uptrend");
         else  doAlert("downtrend");       
   }
   
   return(0);
}
//+------------------------------------------------------------------+


void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," rmo ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," rmo "),message);
             if (alertsSound)   PlaySound(soundfile);
      }
}

      